## ortp 1.0.2

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.0)
project(oRTP VERSION 1.0.2)


set(ORTP_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
set(ORTP_MINOR_VERSION ${PROJECT_VERSION_MINOR})
set(ORTP_MICRO_VERSION ${PROJECT_VERSION_PATCH})
set(ORTP_VERSION ${PROJECT_VERSION})
set(ORTP_SO_VERSION "13") # incremented on January 10, 2017


option(ENABLE_SHARED "Build shared library." YES)
option(ENABLE_STATIC "Build static library." YES)
option(ENABLE_DOC "Enable documentation generation with Doxygen." YES)
option(ENABLE_NTP_TIMESTAMP "Turn on NTP timestamping on packet reception." NO)
option(ENABLE_PERF "Disable costly features to reduce cpu consumtion and increase performance." NO)
option(ENABLE_STRICT "Build with strict compile options." YES)
option(ENABLE_TESTS "Enable compilation of test programs." NO)
option(ENABLE_DEBUG_LOGS "Turn on or off debug level logs." NO)
set(WITH_THREAD_STACK_SIZE "0" CACHE STRING "Set thread stack size (0 is the OS default).")


include(CheckIncludeFile)
include(CheckFunctionExists)
include(GNUInstallDirs)


if(NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

set(MSVC_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/include/MSVC")
if(MSVC)
	list(APPEND CMAKE_REQUIRED_INCLUDES "${MSVC_INCLUDE_DIR}")
endif()

find_package(Threads)
find_library(LIBM NAMES m)

if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
	include("${EP_bctoolbox_CONFIG_DIR}/BcToolboxConfig.cmake")
else()
	find_package(BcToolbox 0.2.0 REQUIRED)
endif()

add_subdirectory(build)

check_include_file(sys/uio.h HAVE_SYS_UIO_H)
check_include_file(sys/audio.h HAVE_SYS_AUDIO_H)
if(NOT ANDROID)
	check_include_file(sys/shm.h HAVE_SYS_SHM_H)
endif()
check_include_file(stdatomic.h HAVE_STDATOMIC_H)
check_function_exists(arc4random HAVE_ARC4RANDOM)

include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)
if(WORDS_BIGENDIAN)
	set(ORTP_BIGENDIAN 1)
endif()


include_directories(
	include/
	src/
	${CMAKE_CURRENT_BINARY_DIR}
)
if(MSVC)
	include_directories(${MSVC_INCLUDE_DIR})
endif()


set(ORTP_CPPFLAGS ${BCTOOLBOX_CPPFLAGS})
if(ENABLE_STATIC)
	list(APPEND ORTP_CPPFLAGS "-DORTP_STATIC")
endif()
if(ENABLE_PERF)
	set(PERF 1)
endif()
if(ENABLE_NTP_TIMESTAMP)
	set(ORTP_TIMESTAMP 1)
	list(APPEND ORTP_CPPFLAGS "-DORTP_TIMESTAMP")
endif()
if(ENABLE_DEBUG_LOGS)
	set(ORTP_DEBUG_MODE 1)
endif()
if(CMAKE_USE_PTHREADS_INIT)
	set(ORTP_DEFAULT_THREAD_STACK_SIZE ${WITH_THREAD_STACK_SIZE})
endif()
if(APPLE)
	set(__APPLE_USE_RFC_3542 1)
endif()
if(ORTP_CPPFLAGS)
	add_definitions(${ORTP_CPPFLAGS})
endif()
set(POSIXTIMER_INTERVAL 10000)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ortp-config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/ortp-config.h)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/ortp-config.h PROPERTIES GENERATED ON)
add_definitions(-DHAVE_CONFIG_H)

set(STRICT_OPTIONS_CPP )
set(STRICT_OPTIONS_C )
if(MSVC)
	if(ENABLE_STRICT)
		list(APPEND STRICT_OPTIONS_CPP "/WX")
	endif()
else()
	list(APPEND STRICT_OPTIONS_CPP "-Wall" "-Wuninitialized")
	list(APPEND STRICT_OPTIONS_C "-Wdeclaration-after-statement" "-Wstrict-prototypes" "-Wno-error=strict-prototypes")
	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
		list(APPEND STRICT_OPTIONS_CPP "-Qunused-arguments" "-Wno-array-bounds")
	endif()
	if(APPLE)
		list(APPEND STRICT_OPTIONS_CPP "-Wno-error=unknown-warning-option" "-Qunused-arguments" "-Wno-tautological-compare" "-Wno-unused-function" "-Wno-array-bounds")
	endif()
	if(ENABLE_STRICT)
		list(APPEND STRICT_OPTIONS_CPP "-Werror" "-Wextra" "-Wno-unused-parameter" "-Wno-missing-field-initializers" "-fno-strict-aliasing")
	endif()
endif()
if(STRICT_OPTIONS_CPP)
	list(REMOVE_DUPLICATES STRICT_OPTIONS_CPP)
endif()
if(STRICT_OPTIONS_C)
	list(REMOVE_DUPLICATES STRICT_OPTIONS_C)
endif()


if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
	set(EXPORT_TARGETS_NAME "LinphoneBuilder")
else()
	set(EXPORT_TARGETS_NAME "ORTP")
endif()


add_subdirectory(include)
add_subdirectory(src)


if(ENABLE_DOC)
	find_package(Doxygen)
	if(DOXYGEN_FOUND)
		set(srcdir ${CMAKE_CURRENT_SOURCE_DIR})
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ortp.doxygen.in ${CMAKE_CURRENT_BINARY_DIR}/ortp.doxygen)
		file(GLOB DOC_INPUT_FILES
			include/ortp/[^.]*.h
			src/[^.]*.h
			src/[^.]*.c
		)
		add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/doc/html/index.html"
			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/ortp.doxygen
			DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/ortp.doxygen ${DOC_INPUT_FILES}
		)
		add_custom_target(ortp-html-doc ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/doc/html/index.html")
		install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc/html"
			DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/ortp-${ORTP_VERSION}")
	endif()
endif()




set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix}/bin)
set(libdir ${prefix}/lib)
set(includedir ${prefix}/include)
set(ORTP_PKGCONFIG_VERSION "${ORTP_VERSION}")
set(ORTPDEPS_LIBS )

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ortp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/ortp.pc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ortp.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/ORTPConfigVersion.cmake"
	VERSION ${ORTP_VERSION}
	COMPATIBILITY AnyNewerVersion
)
export(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE "${CMAKE_CURRENT_BINARY_DIR}/ORTPTargets.cmake"
)
configure_file(ORTPConfig.cmake.in
	"${CMAKE_CURRENT_BINARY_DIR}/ORTPConfig.cmake"
	@ONLY
)

set(CONFIG_PACKAGE_LOCATION "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/cmake")
install(EXPORT ${EXPORT_TARGETS_NAME}Targets
	FILE ORTPTargets.cmake
	DESTINATION ${CONFIG_PACKAGE_LOCATION}
)
install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/ORTPConfig.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/ORTPConfigVersion.cmake"
	DESTINATION ${CONFIG_PACKAGE_LOCATION}
)
install(FILES 	"${CMAKE_CURRENT_SOURCE_DIR}/README.md" 
	"${CMAKE_CURRENT_SOURCE_DIR}/ChangeLog" 
	"${CMAKE_CURRENT_SOURCE_DIR}/COPYING" 
	"${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS" 
	DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/ortp-${ORTP_VERSION}")

=== build/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2017  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

if (NOT CPACK_PACKAGE_NAME)
	set(CPACK_PACKAGE_NAME "ortp")
ENDIF()

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING")

set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})

set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${PROJECT_VERSION})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
"${CMAKE_BINARY_DIR}"
"^${PROJECT_SOURCE_DIR}/.git*"
)
bc_project_build_version(${PROJECT_VERSION} PROJECT_VERSION_BUILD)

set (CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_FILE_NAME}-${PROJECT_VERSION_BUILD}")

message("Package file name is ${CPACK_PACKAGE_FILE_NAME}" )

set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_FILE_NAME})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/rpm/ortp.spec.cmake ${CMAKE_CURRENT_SOURCE_DIR}/../ortp.spec)

include(CPack)

=== include/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(HEADER_FILES
	b64.h
	event.h
	logging.h
	ortp.h
	payloadtype.h
	port.h
	rtcp.h
	rtp.h
	rtpprofile.h
	rtpsession.h
	rtpsignaltable.h
	sessionset.h
	str_utils.h
	telephonyevents.h
	utils.h
)

set(ORTP_HEADER_FILES )
foreach(HEADER_FILE ${HEADER_FILES})
	list(APPEND ORTP_HEADER_FILES "${CMAKE_CURRENT_LIST_DIR}/ortp/${HEADER_FILE}")
endforeach()
set(ORTP_HEADER_FILES ${ORTP_HEADER_FILES} PARENT_SCOPE)

install(FILES ${ORTP_HEADER_FILES}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ortp
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

=== src/tests/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

if (NOT IOS)
	set(EXECUTABLES rtpsend rtprecv mrtpsend mrtprecv test_timer tevrtpsend tevrtprecv rtpsend_stupid)
	foreach(executable ${EXECUTABLES})
		bc_apply_compile_flags(${executable}.c STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
		add_executable(${executable} ${executable}.c)
		target_link_libraries(${executable} ortp)
	endforeach()

	install(TARGETS ${EXECUTABLES}
		RUNTIME DESTINATION bin
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

=== debian/changelog ===
ortp (1:1.0.2-1) unstable; urgency=medium

  * Team upload.
  * Release to unstable

 -- Bernhard Schmidt <berni@debian.org>  Wed, 10 Oct 2018 22:50:59 +0200

ortp (1:1.0.2-0+exp2) experimental; urgency=medium

  * Team upload.
  * Make -dev depend on libbctoolbox-dev
  * Update Vcs-* to salsa
  * Drop Marc Purcell from Uploaders (at his own wish)

 -- Bernhard Schmidt <berni@debian.org>  Fri, 16 Feb 2018 16:26:00 +0100

ortp (1:1.0.2-0+exp1) experimental; urgency=medium

  * Team upload.

  [ Daniel Gnoutcheff ]
  * Initial release separate from linphone (Closes: #785522)

  [ Johannes 'josch' Schauer ]
  * debian/control: bctoolbox-dev got renamed to libbctoolbox-dev
  * debian/rules: no need to add duplicate rule for "build"
  * Instead of patching CMakeLists.txt to remove rpath, pass CMAKE_SKIP_RPATH=ON
  * debian/libortp12.docs: README -> README.md, remove TODO
  * upstream bumped the soname from 12 to 13 - rename libortp12 to libortp13
  * debian/patches: add fix-spelling patch
  * debian/rules: Use hardening=+all
  * debian/compat: Bump debhelper compatibility level to 10
  * add debian/TODO
  * run wrap-and-sort -abt
  * debian/rules: .PHONY: build is not needed either

  [ Jonas Smedegaard ]
  * Tidy copyright info: Wrap license sections at 72 chars, and separate
    paragraphs.
  * Update copyright info: Relabel licenses derived from BSD-3-Clause.
  * Update copyright info: Fix catch-all Files section to be licensed GPL-2+
    (not LGPL-2.1+): Only tests are LGPL nowadays.
  * Tidy copyright info: Sort files.
  * Update copyright info: Add identifiers for some copyright holders.
  * Update copyright info: Add m4 file, licensed FSFULLR.
  * Update copyright info: Separate License grants and references from actual
    licenses.
  * Suppress arguably bogus lintian warning about shared license not written
    verbatim but instead referenced in machine-readable form (see bug#786450).
  * Add copyright-check helper tool.
  * Add copyright hints, to ease tracking later changes.
  * Update copyright info: Fix re-add licence grant for debian dir (including
    boilerplate since this is apparently its canonical location, but rewrapped
    at 72 chars). Add License grant for copyright-check tool.
  * Update copyright hints.

  [ Bernhard Schmidt ]
  * New upstream version 1.0.2
  * Update symbols for libortp13
  * Tighten dependency on libbctoolbox-dev

 -- Bernhard Schmidt <berni@debian.org>  Mon, 16 Oct 2017 00:58:33 +0200

=== debian/watch ===
version=3

opts=\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/ortp-$1\.tar\.gz/,\
  http://github.com/BelledonneCommunications/ortp/tags .*/v?(\d\S*)\.tar\.gz

## ortp 4.4.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # CMakeLists.txt
-# Copyright (C) 2014  Belledonne Communications, Grenoble France
+# Copyright (C) 2010-2019  Belledonne Communications, Grenoble France
 #
 ############################################################################
 #
@@ -20,15 +20,16 @@
 #
 ############################################################################
 
-cmake_minimum_required(VERSION 3.0)
-project(oRTP VERSION 1.0.2)
+cmake_minimum_required(VERSION 3.1)
+project(oRTP VERSION 4.4.0)
 
 
 set(ORTP_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
 set(ORTP_MINOR_VERSION ${PROJECT_VERSION_MINOR})
 set(ORTP_MICRO_VERSION ${PROJECT_VERSION_PATCH})
 set(ORTP_VERSION ${PROJECT_VERSION})
-set(ORTP_SO_VERSION "13") # incremented on January 10, 2017
+set(ORTP_SO_VERSION "15") # incremented for 4.4.0 version.
+set(ORTP_DOC_VERSION "${ORTP_VERSION_MAJOR}.${ORTP_VERSION_MINOR}")
 
 
 option(ENABLE_SHARED "Build shared library." YES)
@@ -39,13 +40,15 @@
 option(ENABLE_STRICT "Build with strict compile options." YES)
 option(ENABLE_TESTS "Enable compilation of test programs." NO)
 option(ENABLE_DEBUG_LOGS "Turn on or off debug level logs." NO)
+option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making (CMake >= 3.11)" OFF)
 set(WITH_THREAD_STACK_SIZE "0" CACHE STRING "Set thread stack size (0 is the OS default).")
 
 
 include(CheckIncludeFile)
 include(CheckFunctionExists)
 include(GNUInstallDirs)
-
+include(CheckCSourceCompiles)
+include(CheckSymbolExists)
 
 if(NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
 	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
@@ -60,21 +63,25 @@
 find_package(Threads)
 find_library(LIBM NAMES m)
 
-if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
-	include("${EP_bctoolbox_CONFIG_DIR}/BcToolboxConfig.cmake")
-else()
-	find_package(BcToolbox 0.2.0 REQUIRED)
-endif()
-
-add_subdirectory(build)
+find_package(bctoolbox 0.2.0 REQUIRED)
 
 check_include_file(sys/uio.h HAVE_SYS_UIO_H)
 check_include_file(sys/audio.h HAVE_SYS_AUDIO_H)
 if(NOT ANDROID)
 	check_include_file(sys/shm.h HAVE_SYS_SHM_H)
 endif()
-check_include_file(stdatomic.h HAVE_STDATOMIC_H)
+check_c_source_compiles("#include <stdatomic.h>
+int main(int argc, char *argv[]) {
+atomic_int currrent_ref;
+atomic_init(&currrent_ref, 1);
+atomic_int previous_ref = atomic_fetch_sub_explicit(&currrent_ref, 1, memory_order_release);
+return 0;
+}"
+        HAVE_STDATOMIC_H)
+
 check_function_exists(arc4random HAVE_ARC4RANDOM)
+check_symbol_exists(recvmsg "sys/socket.h" HAVE_RECVMSG)
+check_symbol_exists(sendmsg "sys/socket.h" HAVE_SENDMSG)
 
 include(TestBigEndian)
 test_big_endian(WORDS_BIGENDIAN)
@@ -121,16 +128,22 @@
 set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/ortp-config.h PROPERTIES GENERATED ON)
 add_definitions(-DHAVE_CONFIG_H)
 
+# Enable stdint.h limit macros on C++ files. (Windows only.)
+if(MSVC)
+	add_definitions("-D__STDC_LIMIT_MACROS")
+endif()
+
 set(STRICT_OPTIONS_CPP )
 set(STRICT_OPTIONS_C )
 if(MSVC)
 	if(ENABLE_STRICT)
 		list(APPEND STRICT_OPTIONS_CPP "/WX")
 	endif()
+    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
 else()
 	list(APPEND STRICT_OPTIONS_CPP "-Wall" "-Wuninitialized")
 	list(APPEND STRICT_OPTIONS_C "-Wdeclaration-after-statement" "-Wstrict-prototypes" "-Wno-error=strict-prototypes")
-	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+	if(CMAKE_C_COMPILER_ID MATCHES "Clang")
 		list(APPEND STRICT_OPTIONS_CPP "-Qunused-arguments" "-Wno-array-bounds")
 	endif()
 	if(APPLE)
@@ -147,13 +160,7 @@
 	list(REMOVE_DUPLICATES STRICT_OPTIONS_C)
 endif()
 
-
-if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
-	set(EXPORT_TARGETS_NAME "LinphoneBuilder")
-else()
-	set(EXPORT_TARGETS_NAME "ORTP")
-endif()
-
+set(EXPORT_TARGET_NAME ortp)
 
 add_subdirectory(include)
 add_subdirectory(src)
@@ -192,34 +199,42 @@
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ortp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/ortp.pc)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ortp.pc DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
 
+if (ENABLE_PACKAGE_SOURCE)
+	add_subdirectory(build)
+endif()
+
 include(CMakePackageConfigHelpers)
+
+set(CONFIG_PACKAGE_LOCATION "${CMAKE_INSTALL_LIBDIR}/cmake/${EXPORT_TARGET_NAME}")
+
 write_basic_package_version_file(
-	"${CMAKE_CURRENT_BINARY_DIR}/ORTPConfigVersion.cmake"
+	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}ConfigVersion.cmake"
 	VERSION ${ORTP_VERSION}
 	COMPATIBILITY AnyNewerVersion
 )
-export(EXPORT ${EXPORT_TARGETS_NAME}Targets
-	FILE "${CMAKE_CURRENT_BINARY_DIR}/ORTPTargets.cmake"
-)
-configure_file(ORTPConfig.cmake.in
-	"${CMAKE_CURRENT_BINARY_DIR}/ORTPConfig.cmake"
-	@ONLY
-)
-
-set(CONFIG_PACKAGE_LOCATION "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/cmake")
-install(EXPORT ${EXPORT_TARGETS_NAME}Targets
-	FILE ORTPTargets.cmake
+export(EXPORT "${EXPORT_TARGET_NAME}Targets"
+	FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Targets.cmake"
+)
+
+configure_package_config_file(ORTPConfig.cmake.in
+	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Config.cmake"
+	INSTALL_DESTINATION ${CONFIG_PACKAGE_LOCATION}
+	NO_SET_AND_CHECK_MACRO
+)
+
+install(EXPORT ${EXPORT_TARGET_NAME}Targets
+	FILE "${EXPORT_TARGET_NAME}Targets.cmake"
 	DESTINATION ${CONFIG_PACKAGE_LOCATION}
 )
+
 install(FILES
-	"${CMAKE_CURRENT_BINARY_DIR}/ORTPConfig.cmake"
-	"${CMAKE_CURRENT_BINARY_DIR}/ORTPConfigVersion.cmake"
+	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Config.cmake"
+	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}ConfigVersion.cmake"
 	DESTINATION ${CONFIG_PACKAGE_LOCATION}
 )
 install(FILES 	"${CMAKE_CURRENT_SOURCE_DIR}/README.md" 
-	"${CMAKE_CURRENT_SOURCE_DIR}/ChangeLog" 
-	"${CMAKE_CURRENT_SOURCE_DIR}/COPYING" 
-	"${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS" 
-	DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/ortp-${ORTP_VERSION}")
-
-
+	"${CMAKE_CURRENT_SOURCE_DIR}/CHANGELOG.md" 
+	"${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt" 
+	"${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS.md" 
+	DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/ortp-${ORTP_DOC_VERSION}"
+)

=== include/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
 	b64.h
 	event.h
 	logging.h
+	nack.h
 	ortp.h
 	payloadtype.h
 	port.h

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(LIBS )
if(NOT ANDROID)
	list(APPEND LIBS ${CMAKE_THREAD_LIBS_INIT})
endif()
if(HAVE_RT)
	list(APPEND LIBS rt)
endif()
if(LIBM)
	list(APPEND LIBS ${LIBM})
endif()

set(ORTP_SOURCE_FILES_C
	avprofile.c
	b64.c
	congestiondetector.c
	event.c
	extremum.c
	jitterctl.c
	kalmanrls.c
	logging.c
	nack.c
	netsim.c
	ortp.c
	payloadtype.c
	port.c
	posixtimer.c
	rtcp.c
	rtcp_fb.c
	rtcp_xr.c
	rtcpparse.c
	rtpparse.c
	rtpprofile.c
	rtpsession.c
	rtpsession_inet.c
	rtpsignaltable.c
	rtptimer.c
	scheduler.c
	sessionset.c
	str_utils.c
	telephonyevents.c
	videobandwidthestimator.c
	utils.c
)
set(ORTP_SOURCE_FILES_CXX
	rtpbundle.cc
)

add_definitions(
	-DBCTBX_LOG_DOMAIN="ortp"
)

if(WIN32)
	list(APPEND ORTP_SOURCE_FILES_C dll_entry.c)
	if(CMAKE_SYSTEM_NAME STREQUAL "WindowsPhone")
		list(APPEND ORTP_SOURCE_FILES_CXX winrttimer.cpp winrttimer.h)
		set_source_files_properties(winrttimer.cpp PROPERTIES COMPILE_FLAGS "/ZW /AI\$(WindowsSDK_MetadataPath)")
	endif()
endif()

if(WIN32)
	add_definitions(-DWINDOWS_NATIVE)
	if(NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
		list(APPEND LIBS ws2_32)
	endif()
	if(NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsPhone" AND NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
		list(APPEND LIBS delayimp Winmm Qwave)
	endif()
endif()

bc_apply_compile_flags(ORTP_SOURCE_FILES_C STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
bc_apply_compile_flags(ORTP_SOURCE_FILES_CXX STRICT_OPTIONS_CPP STRICT_OPTIONS_CXX)

if(ENABLE_STATIC)
	add_library(ortp-static STATIC ${ORTP_HEADER_FILES} ${ORTP_SOURCE_FILES_C} ${ORTP_SOURCE_FILES_CXX})
	set_target_properties(ortp-static PROPERTIES OUTPUT_NAME ortp)
	set_target_properties(ortp-static PROPERTIES CXX_STANDARD 11 CXX_STANDARD_REQUIRED ON)
	target_compile_definitions(ortp-static PRIVATE "ORTP_EXPORTS")
	target_link_libraries(ortp-static INTERFACE ${LIBS})
	install(TARGETS ortp-static EXPORT ${EXPORT_TARGET_NAME}Targets
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()
if(ENABLE_SHARED)
	add_library(ortp SHARED ${ORTP_HEADER_FILES} ${ORTP_SOURCE_FILES_C} ${ORTP_SOURCE_FILES_CXX})
	set_target_properties(ortp PROPERTIES LINKER_LANGUAGE CXX)
	set_target_properties(ortp PROPERTIES CXX_STANDARD 11 CXX_STANDARD_REQUIRED ON)
	if(APPLE)
		if(IOS)
			set(MIN_OS ${LINPHONE_IOS_DEPLOYMENT_TARGET})
		else()
			set(MIN_OS ${CMAKE_OSX_DEPLOYMENT_TARGET})
		endif()
		set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/osx/")
		set_target_properties(ortp PROPERTIES
			FRAMEWORK TRUE
			MACOSX_FRAMEWORK_IDENTIFIER org.linphone.ortp
  			MACOSX_FRAMEWORK_INFO_PLIST Info.plist.in
			PUBLIC_HEADER "${ORTP_HEADER_FILES}"
		)
	endif()
	if(NOT ANDROID)
		# Do not version shared library on Android
		set_target_properties(ortp PROPERTIES SOVERSION ${ORTP_SO_VERSION})
	endif()
	if(WIN32)
		target_compile_options(ortp PRIVATE "/DELAYLOAD:Qwave.dll")
	endif()
	target_compile_definitions(ortp PRIVATE "ORTP_EXPORTS")
	target_include_directories(ortp
		INTERFACE $<INSTALL_INTERFACE:include>
	)
	target_link_libraries(ortp PUBLIC bctoolbox PRIVATE ${LIBS})
	if(MSVC)
		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
			install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE}/ortp.pdb
				DESTINATION ${CMAKE_INSTALL_BINDIR}
				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			)
		endif()
	endif()
	install(TARGETS ortp EXPORT ${EXPORT_TARGET_NAME}Targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		FRAMEWORK DESTINATION Frameworks
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

if(ENABLE_TESTS AND NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsPhone" AND NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
	add_subdirectory(tests)
endif()

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -21,15 +21,15 @@
 ############################################################################
 
 if (NOT IOS)
-	set(EXECUTABLES rtpsend rtprecv mrtpsend mrtprecv test_timer tevrtpsend tevrtprecv rtpsend_stupid)
+	set(EXECUTABLES rtpsend rtprecv mrtpsend mrtprecv test_timer tevrtpsend tevrtprecv rtpsend_stupid rtpextensionheader)
 	foreach(executable ${EXECUTABLES})
 		bc_apply_compile_flags(${executable}.c STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
 		add_executable(${executable} ${executable}.c)
-		target_link_libraries(${executable} ortp)
+		target_link_libraries(${executable} ortp ${BCTOOLBOX_CORE_LIBRARIES})
 	endforeach()
 
 	install(TARGETS ${EXECUTABLES}
-		RUNTIME DESTINATION bin
+                RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
 		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
 	)
 endif()

=== debian/changelog ===
ortp (1:4.4.13-2ubuntu1) hirsute; urgency=medium

  * Fix build on ppc64el and s390x by lowering optimization level

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 27 Dec 2020 12:23:17 +0100

ortp (1:4.4.13-2) unstable; urgency=medium

  * Team upload.
  * Release to unstable.
  * Drop Daniel Gnoutcheff from Uploaders
  * Add myself to uploaders

 -- Bernhard Schmidt <berni@debian.org>  Fri, 25 Dec 2020 14:35:31 +0100

ortp (1:4.4.13-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.4.13
  * Change Vcs-* to linphone-stack subgroup

 -- Bernhard Schmidt <berni@debian.org>  Mon, 07 Dec 2020 11:10:55 +0100

ortp (1:4.4.0-1) experimental; urgency=medium

  * New upstream version 4.4.0
  * SONAME bump libortp14 -> libortp15, tighten build-dep on bctoolbox

 -- Bernhard Schmidt <berni@debian.org>  Tue, 01 Sep 2020 00:30:42 +0200

ortp (1:4.3.2-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.3.2
  * d/watch: Switch to upstream primary Gitlab, only use releases
  * SONAME bump libortp13 -> libortp14
  * Switch from symbols to shlibs, this is a tightly coupled library
    solely used in the Linphone stack
  * Adjust upstream paths
  * Bump to debhelper-compat 12
  * Update RFCs in package description (Closes: #856435)

 -- Bernhard Schmidt <berni@debian.org>  Mon, 01 Jun 2020 23:10:38 +0200

=== debian/control ===
Source: ortp
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Kilian Krause <kilian@debian.org>,
           Tzafrir Cohen <tzafrir@debian.org>,
           Felix Lechner <felix.lechner@gmail.com>,
           Bernhard Schmidt <berni@debian.org>,
Build-Depends: cmake (>= 3),
               debhelper-compat (= 12),
               doxygen,
               libbctoolbox-dev (>= 4.4.0~),
Standards-Version: 4.5.0
Section: libs
Homepage: http://www.linphone.org/technical-corner/ortp/overview
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/ortp
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/ortp.git

Package: libortp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbctoolbox-dev (>= 4.4.0~),
         libortp15 (= ${binary:Version}),
         ${misc:Depends},
Description: Development files for the ortp RTP library
 This library implements RFC 3550 (RTP) and offers an easy to
 use API with high-level and low-level access. It is part of
 Linphone.
 .
 The main features are support for multiple profiles (AV profile
 RFC 3551 being the default one); an optional packet scheduler
 for synchronizing RTP recv and send; blocking or non-blocking
 IO for RTP sessions; multiplexed IO; some of RFC 4733 for
 telephone events over RTP.
 .
 This package contains the development files.

Package: libortp-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery,
         ${misc:Depends},
Suggests: libortp-dev,
Description: oRTP API documentation
 This library implements RFC 3550 (RTP) and offers an easy to
 use API with high-level and low-level access. It is part of
 Linphone.
 .
 The main features are support for multiple profiles (AV profile
 RFC 3551 being the default one); an optional packet scheduler
 for synchronizing RTP recv and send; blocking or non-blocking
 IO for RTP sessions; multiplexed IO; some of RFC 4733 for
 telephone events over RTP.
 .
 This package contains the API documentation.

Package: libortp15
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Real-time Transport Protocol (RTP) stack
 This library implements RFC 3550 (RTP) and offers an easy to
 use API with high-level and low-level access. It is part of
 Linphone.
 .
 The main features are support for multiple profiles (AV profile
 RFC 3551 being the default one); an optional packet scheduler
 for synchronizing RTP recv and send; blocking or non-blocking
 IO for RTP sessions; multiplexed IO; some of RFC 4733 for
 telephone events over RTP.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
ifeq ($(DEB_HOST_ARCH),ppc64el)
export DEB_CFLAGS_MAINT_APPEND = -O2
endif
ifeq ($(DEB_HOST_ARCH),s390x)
export DEB_CFLAGS_MAINT_APPEND = -O1
endif

%:
	dh $@ --buildsystem=cmake

# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON

## ortp 5.1.64

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # CMakeLists.txt
-# Copyright (C) 2010-2019  Belledonne Communications, Grenoble France
+# Copyright (C) 2010-2021 Belledonne Communications, Grenoble France
 #
 ############################################################################
 #
@@ -21,7 +21,14 @@
 ############################################################################
 
 cmake_minimum_required(VERSION 3.1)
-project(oRTP VERSION 4.4.0)
+
+# CMP0077 policy is required by Flexisip build. Remove it once the CMake required
+# version is higer or equal to 3.13.
+if(NOT CMAKE_VERSION VERSION_LESS 3.13)
+    cmake_policy(SET CMP0077 NEW)
+endif()
+
+project(oRTP VERSION 5.1.0)
 
 
 set(ORTP_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
@@ -44,6 +51,10 @@
 set(WITH_THREAD_STACK_SIZE "0" CACHE STRING "Set thread stack size (0 is the OS default).")
 
 
+# Hidden non-cache options:
+# * DISABLE_BC_PACKAGE_SEARCH: skip find_package() for every BC package (bctoolbox, ortp, etc.)
+
+
 include(CheckIncludeFile)
 include(CheckFunctionExists)
 include(GNUInstallDirs)
@@ -63,7 +74,9 @@
 find_package(Threads)
 find_library(LIBM NAMES m)
 
-find_package(bctoolbox 0.2.0 REQUIRED)
+if(NOT DISABLE_BC_PACKAGE_SEARCH)
+	find_package(bctoolbox 0.2.0 REQUIRED)
+endif()
 
 check_include_file(sys/uio.h HAVE_SYS_UIO_H)
 check_include_file(sys/audio.h HAVE_SYS_AUDIO_H)
@@ -212,9 +225,11 @@
 	VERSION ${ORTP_VERSION}
 	COMPATIBILITY AnyNewerVersion
 )
-export(EXPORT "${EXPORT_TARGET_NAME}Targets"
-	FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Targets.cmake"
-)
+if(LINPHONE_BUILDER_GROUP_EXTERNAL_SOURCE_PATH_BUILDERS)
+	export(EXPORT "${EXPORT_TARGET_NAME}Targets"
+		FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Targets.cmake"
+	)
+endif()
 
 configure_package_config_file(ORTPConfig.cmake.in
 	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_TARGET_NAME}Config.cmake"
@@ -236,5 +251,5 @@
 	"${CMAKE_CURRENT_SOURCE_DIR}/CHANGELOG.md" 
 	"${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt" 
 	"${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS.md" 
-	DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/ortp-${ORTP_DOC_VERSION}"
-)
+	DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/ortp-${ORTP_VERSION}"
+)

=== build/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2010-2019  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.11) # we need CMake 3.11 for defining 'package_source' target as custom target

if (NOT CPACK_PACKAGE_NAME)
	set(CPACK_PACKAGE_NAME "ortp")
endif()

set(CPACK_SOURCE_IGNORE_FILES "./.*")

bc_make_package_source_target()

=== include/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,8 @@
 
 set(HEADER_FILES
 	b64.h
-	event.h
+        event.h
+        fecstream.h
 	logging.h
 	nack.h
 	ortp.h

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # CMakeLists.txt
-# Copyright (C) 2014  Belledonne Communications, Grenoble France
+# Copyright (C) 2010-2021 Belledonne Communications, Grenoble France
 #
 ############################################################################
 #
@@ -37,6 +37,7 @@
 	congestiondetector.c
 	event.c
 	extremum.c
+        fecstream.c
 	jitterctl.c
 	kalmanrls.c
 	logging.c
@@ -50,6 +51,7 @@
 	rtcp_fb.c
 	rtcp_xr.c
 	rtcpparse.c
+	rtpaudiolevel.c
 	rtpparse.c
 	rtpprofile.c
 	rtpsession.c
@@ -77,6 +79,7 @@
 		list(APPEND ORTP_SOURCE_FILES_CXX winrttimer.cpp winrttimer.h)
 		set_source_files_properties(winrttimer.cpp PROPERTIES COMPILE_FLAGS "/ZW /AI\$(WindowsSDK_MetadataPath)")
 	endif()
+	list(APPEND LIBS ws2_32)# symbols for in6addr_any
 endif()
 
 if(WIN32)
@@ -97,7 +100,11 @@
 	set_target_properties(ortp-static PROPERTIES OUTPUT_NAME ortp)
 	set_target_properties(ortp-static PROPERTIES CXX_STANDARD 11 CXX_STANDARD_REQUIRED ON)
 	target_compile_definitions(ortp-static PRIVATE "ORTP_EXPORTS")
-	target_link_libraries(ortp-static INTERFACE ${LIBS})
+	target_include_directories(ortp-static
+		PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
+		$<INSTALL_INTERFACE:include>
+	)
+	target_link_libraries(ortp-static PUBLIC bctoolbox INTERFACE ${LIBS})
 	install(TARGETS ortp-static EXPORT ${EXPORT_TARGET_NAME}Targets
 		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
 		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
@@ -113,7 +120,7 @@
 		else()
 			set(MIN_OS ${CMAKE_OSX_DEPLOYMENT_TARGET})
 		endif()
-		set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/osx/")
+		set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/build/osx/")
 		set_target_properties(ortp PROPERTIES
 			FRAMEWORK TRUE
 			MACOSX_FRAMEWORK_IDENTIFIER org.linphone.ortp
@@ -130,12 +137,13 @@
 	endif()
 	target_compile_definitions(ortp PRIVATE "ORTP_EXPORTS")
 	target_include_directories(ortp
-		INTERFACE $<INSTALL_INTERFACE:include>
+		PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
+		$<INSTALL_INTERFACE:include>
 	)
 	target_link_libraries(ortp PUBLIC bctoolbox PRIVATE ${LIBS})
 	if(MSVC)
 		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
-			install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_BUILD_TYPE}/ortp.pdb
+			install(FILES $<TARGET_PDB_FILE:ortp>
 				DESTINATION ${CMAKE_INSTALL_BINDIR}
 				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
 			)

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 ############################################################################
 
 if (NOT IOS)
-	set(EXECUTABLES rtpsend rtprecv mrtpsend mrtprecv test_timer tevrtpsend tevrtprecv rtpsend_stupid rtpextensionheader)
+        set(EXECUTABLES rtpsend rtprecv mrtpsend mrtprecv test_timer tevrtpsend tevrtprecv rtpsend_stupid rtpextensionheader fectest)
 	foreach(executable ${EXECUTABLES})
 		bc_apply_compile_flags(${executable}.c STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
 		add_executable(${executable} ${executable}.c)

=== debian/changelog ===
ortp (1:5.1.64-2) unstable; urgency=medium

  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Sun, 27 Nov 2022 17:33:08 +0100

ortp (1:5.1.64-1) experimental; urgency=medium

  * New upstream version 5.1.64
  * Bump SOVERSION to 16 due to ABI break.
  * Honour nodoc build profile
  * Fix i386 FTBFS occurring on reproducible-builds.org

 -- Dennis Filder <d.filder@web.de>  Tue, 04 Oct 2022 22:46:03 +0200

ortp (1:5.0.37-2) unstable; urgency=medium

  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Mon, 12 Sep 2022 10:58:11 +0200

ortp (1:5.0.37-1) experimental; urgency=medium

  [ Dennis Filder ]
  * New upstream version 5.0.37
  * Drop static library from libortp-dev.  File a bug if you need it back.
  * Express a versioned pkg-config Requires.private: on bctoolbox
    (Closes: #994437)
  * arch:all and arch:any packages are now buildable separately

 -- Bernhard Schmidt <berni@debian.org>  Fri, 21 Jan 2022 23:36:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,26 @@
 Source: ortp
 Priority: optional
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
-Uploaders: Kilian Krause <kilian@debian.org>,
-           Tzafrir Cohen <tzafrir@debian.org>,
-           Felix Lechner <felix.lechner@gmail.com>,
+Uploaders: Felix Lechner <felix.lechner@gmail.com>,
            Bernhard Schmidt <berni@debian.org>,
-Build-Depends: cmake (>= 3),
-               debhelper-compat (= 12),
-               doxygen,
-               libbctoolbox-dev (>= 4.4.0~),
-Standards-Version: 4.5.0
+Build-Depends: cmake,
+               debhelper-compat (= 13),
+               libbctoolbox-dev (>= 5.1.64~),
+Build-Depends-Indep: doxygen <!nodoc>,
+Standards-Version: 4.6.1
+Rules-Requires-Root: no
 Section: libs
-Homepage: http://www.linphone.org/technical-corner/ortp/overview
+Homepage: https://www.linphone.org/technical-corner/ortp
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/ortp
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/ortp.git
+Description: Real-time Transport Protocol (RTP) library
 
 Package: libortp-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libbctoolbox-dev (>= 4.4.0~),
-         libortp15 (= ${binary:Version}),
+Depends: libbctoolbox-dev (>= 5.1.64~),
+         libortp16 (= ${binary:Version}),
          ${misc:Depends},
 Description: Development files for the ortp RTP library
  This library implements RFC 3550 (RTP) and offers an easy to
@@ -37,6 +37,7 @@
 
 Package: libortp-doc
 Section: doc
+Build-Profiles: <!nodoc>
 Architecture: all
 Multi-Arch: foreign
 Depends: libjs-jquery,
@@ -55,7 +56,7 @@
  .
  This package contains the API documentation.
 
-Package: libortp15
+Package: libortp16
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends},

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

DEB_REQUESTED_PACKAGES := $(shell dh_listpackages)
when-in-build-profile     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-not-in-build-profile = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-building-package     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))
when-not-building-package = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
ortp_so_version = $(shell sed -n 's@set(ORTP_SO_VERSION "*\([0-9]\+\)"*).*$$@\1@p' CMakeLists.txt)

%:
	dh $@ --buildsystem=cmake

# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
override_dh_auto_configure:
	[ -n "$(ortp_so_version)" -a "$(ortp_so_version)" -ge 16 ] # break build early if SOVERSION parsing fails
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DENABLE_STATIC=no -DDEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM)

override_dh_auto_build-arch:
	dh_auto_build -O--buildsystem=cmake -- ortp

override_dh_auto_build-indep:
ifeq (x,$(call when-building-package,libortp-doc,x))
	dh_auto_build -O--buildsystem=cmake -- ortp-html-doc
endif

execute_after_dh_auto_install-indep:
	rm -f debian/tmp/usr/share/doc/ortp/CHANGELOG.md
	true

# The version number specified here relies on all linphone-stack
# libraries being versioned in lock-step which is apparently their
# approach now.
execute_after_dh_auto_install-arch:
	echo 'Requires.private: bctoolbox >= $(DEB_VERSION_UPSTREAM)' >> debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/ortp.pc
	rm -f debian/tmp/usr/share/doc/ortp/CHANGELOG.md

execute_before_dh_auto_install-arch:
# fake arch-independent build artefacts
	if [ ! -d obj-$(DEB_HOST_GNU_TYPE)/doc/html ]; then \
		mkdir -p obj-$(DEB_HOST_GNU_TYPE)/doc/html ; \
	fi

execute_before_dh_auto_install-indep:
# fake arch-dependent build artefacts
	if [ ! -f obj-$(DEB_HOST_GNU_TYPE)/src/libortp.so.$(ortp_so_version) ]; then \
		touch obj-$(DEB_HOST_GNU_TYPE)/src/libortp.so.$(ortp_so_version); \
	fi
	if [ ! -L obj-$(DEB_HOST_GNU_TYPE)/src/libortp.so ]; then \
		ln -fs obj-$(DEB_HOST_GNU_TYPE)/src/libortp.so.$(ortp_so_version) \
			obj-$(DEB_HOST_GNU_TYPE)/src/libortp.so; \
	fi

override_dh_autoreconf_clean:
override_dh_autoreconf:
